/*
 * @Description:
 * @Version: 2.0
 * @Autor: shimnx
 * @Date: 2022-05-18 18:17:27
 * @LastEditors: shimnx
 * @LastEditTime: 2022-12-08 11:11:10
 */
/**
 * Status Column implementation file
 */

// Bryntum umd lite bundle comes without polyfills to support Angular's zone.js
import { Column, ColumnStore } from '@bryntum/gantt/gantt.lite.umd.js';
import { DateHelper } from '@bryntum/gantt/gantt.lite.umd.js';
/**
 * @module FinishColumn
 */

/**
 * A column showing the status of a task
 *
 * @extends Gantt/column/Column
 * @classType FinishColumn
 */
export default class FinishColumn extends Column {

    static get $name() {
        return 'FinishColumn';
    }

    static get type() {
        return 'finishcolumn';
    }

    static get isGanttColumn() {
        return true;
    }

    static get defaults() {
        return {
            // Set your default instance config properties here
            field      : 'finish',
            text       : 'Finish Date',
            editor     : {
                type : 'date',

            },
            htmlEncode : false,

        };
    }
    get finish() {
        let result = this.endDate;
        console.log(result)
        if (result) {
            // return original endDate plus 24 hours
            result = new Date(result.getTime() + 24 * 3600000);
        }

        return result;
    }

    set finish(value) {
        console.log(value)

        if (value) {
            // write to original endDate value minus 24 hours
            value = new Date(value.getTime() - 24 * 3600000);
        }

        this.endDate = value;
    }
    //endregion

    renderer({ record }) {
        const finish = DateHelper.format(new Date(record.endDate.getTime() - 24 * 3600000), 'MMM DD, YYYY');
        console.log(finish)
        return finish ? {
            tag       : 'i',
            className : `b-fa ${finish}`,
            html      : finish
        } : '';
    }

}

ColumnStore.registerColumnType(FinishColumn);
